// ALOHA.h: interface for the ALOHA class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _ALOHA_H
#define _ALOHA_H

#include "mac.h"
#include "defines.h"




class cALOHA : public cMAC  
{
public:
	
	bool Idle;

	Packet pktToSend;
	bool pktSent;
	bool firstSent;
	
	cALOHA(short Id,FILE* fptr,macParameter macParam);
	 ~cALOHA();


	
	bool  macSend(Packet pkt);//define a pure virtual function that will be implemented by the derived classes
	
	//All these are to control the input from the simulation core loop
	bool macToneDetected(EventInfo & eventInformation) ;//phyinterfaceUPDATE
	
	bool macDataRxStart(EventInfo& eventInformation, channelState initState);
	bool macDataRxEnd(EventInfo& eventInformation, channelState initState);
	bool macDataTxEnd(EventInfo& eventInformation, channelState initState);
	bool macTimerExpire(EventInfo& eventInformation);	
	bool slotTime(EventInfo& eventInformation);

	bool isIdle(){ return (Idle);};

	bool resetMAC(){
		Idle= true;
		underwaterPhy.resetPhy();	
		firstSent=false;
		pktSent=false;
		return true;
		};
};

#endif 
