// slottedALOHA.h: interface for the ALOHA class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _SALOHA_H
#define _SALOHA_H

#include "mac.h"
#include "defines.h"




class cSALOHA : public cMAC  
{
public:
	
	
	bool Idle;

	Packet pktToSend;
	bool pktSent;
	
	cSALOHA(short Id,FILE* fptr,macParameter macParam);
	 ~cSALOHA();


	
	bool  macSend(Packet pkt);//define a pure virtual function that will be implemented by the derived classes
	
	//All these are to control the input from the simulation core loop
	bool macToneDetected(EventInfo & eventInformation) ;//phyinterfaceUPDATE
	
	bool macDataRxStart(EventInfo& eventInformation, channelState initState);
	bool macDataRxEnd(EventInfo& eventInformation, channelState initState);
	bool macDataTxEnd(EventInfo& eventInformation, channelState initState);
	bool macTimerExpire(EventInfo& eventInformation);	
	bool slotTime(EventInfo& eventInformation);
	bool initSlotTime();

	bool isIdle(){ return (Idle);};

	bool resetMAC(){
		Idle= true;
		underwaterPhy.resetPhy();	
		initSlotTime();//to restart the repeated ST events
		return true;
		};
};

#endif 
